<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelSearchCriterionType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfHotelSearchCriterionType extends AbstractStructArrayBase
{
    /**
     * The HotelSearchCriterionType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgHotelSearchCriterionType[]
     */
    public $HotelSearchCriterionType;
    /**
     * Constructor method for ArrayOfHotelSearchCriterionType
     * @uses DgArrayOfHotelSearchCriterionType::setHotelSearchCriterionType()
     * @param \dgsoft\StructType\DgHotelSearchCriterionType[] $hotelSearchCriterionType
     */
    public function __construct(array $hotelSearchCriterionType = array())
    {
        $this
            ->setHotelSearchCriterionType($hotelSearchCriterionType);
    }
    /**
     * Get HotelSearchCriterionType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgHotelSearchCriterionType[]|null
     */
    public function getHotelSearchCriterionType()
    {
        return isset($this->HotelSearchCriterionType) ? $this->HotelSearchCriterionType : null;
    }
    /**
     * Set HotelSearchCriterionType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgHotelSearchCriterionType[] $hotelSearchCriterionType
     * @return \dgsoft\ArrayType\DgArrayOfHotelSearchCriterionType
     */
    public function setHotelSearchCriterionType(array $hotelSearchCriterionType = array())
    {
        foreach ($hotelSearchCriterionType as $arrayOfHotelSearchCriterionTypeHotelSearchCriterionTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelSearchCriterionTypeHotelSearchCriterionTypeItem instanceof \dgsoft\StructType\DgHotelSearchCriterionType) {
                throw new \InvalidArgumentException(sprintf('The HotelSearchCriterionType property can only contain items of \dgsoft\StructType\DgHotelSearchCriterionType, "%s" given', is_object($arrayOfHotelSearchCriterionTypeHotelSearchCriterionTypeItem) ? get_class($arrayOfHotelSearchCriterionTypeHotelSearchCriterionTypeItem) : gettype($arrayOfHotelSearchCriterionTypeHotelSearchCriterionTypeItem)), __LINE__);
            }
        }
        if (is_null($hotelSearchCriterionType) || (is_array($hotelSearchCriterionType) && empty($hotelSearchCriterionType))) {
            unset($this->HotelSearchCriterionType);
        } else {
            $this->HotelSearchCriterionType = $hotelSearchCriterionType;
        }
        return $this;
    }
    /**
     * Add item to HotelSearchCriterionType value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgHotelSearchCriterionType $item
     * @return \dgsoft\ArrayType\DgArrayOfHotelSearchCriterionType
     */
    public function addToHotelSearchCriterionType(\dgsoft\StructType\DgHotelSearchCriterionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgHotelSearchCriterionType) {
            throw new \InvalidArgumentException(sprintf('The HotelSearchCriterionType property can only contain items of \dgsoft\StructType\DgHotelSearchCriterionType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelSearchCriterionType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgHotelSearchCriterionType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgHotelSearchCriterionType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgHotelSearchCriterionType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgHotelSearchCriterionType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgHotelSearchCriterionType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelSearchCriterionType
     */
    public function getAttributeName()
    {
        return 'HotelSearchCriterionType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfHotelSearchCriterionType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
